Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/date/DateFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/date/DateFunction.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/date/DateFunction.java	(revision 44198)
@@ -4,15 +4,16 @@
 import java.text.SimpleDateFormat;
 import java.util.Date;
 import org.apache.commons.lang3.Range;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_DATE;
 import org.gvsig.expressionevaluator.Interpreter;
 import org.gvsig.expressionevaluator.spi.AbstractFunction;
 
 public class DateFunction extends AbstractFunction {
 
     public DateFunction() {
-        super("Date", "DATE",Range.between(1,2),
+        super("Date", FUNCTION_DATE,Range.between(1,2),
             "Returns a date from the arguments",
-            "DATE({{date}}, format)",
+            FUNCTION_DATE+"({{date}}, format)",
             new String[]{
                 "date - a string with a date",
                 "format - Optional. Format to use to parse the date"
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/date/TimeFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/date/TimeFunction.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/date/TimeFunction.java	(revision 44198)
@@ -4,15 +4,16 @@
 import java.text.SimpleDateFormat;
 import java.util.Date;
 import org.apache.commons.lang3.Range;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_TIME;
 import org.gvsig.expressionevaluator.Interpreter;
 import org.gvsig.expressionevaluator.spi.AbstractFunction;
 
 public class TimeFunction extends AbstractFunction {
 
     public TimeFunction() {
-        super("Date", "TIME",Range.between(1,2),
+        super("Date", FUNCTION_TIME,Range.between(1,2),
             "Returns a time from the arguments",
-            "TIME({{time}}, format)",
+            FUNCTION_TIME+"({{time}}, format)",
             new String[]{
                 "time - a string with a time",
                 "format - Optional. Format to use to parse the time"
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/date/NowFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/date/NowFunction.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/date/NowFunction.java	(revision 44198)
@@ -2,15 +2,16 @@
 
 import java.util.Date;
 import org.apache.commons.lang3.Range;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_NOW;
 import org.gvsig.expressionevaluator.Interpreter;
 import org.gvsig.expressionevaluator.spi.AbstractFunction;
 
 public class NowFunction extends AbstractFunction {
 
     public NowFunction() {
-        super("Date", "NOW",Range.is(0),
+        super("Date", FUNCTION_NOW,Range.is(0),
             "Returns current date and time\n",
-            "NOW()",
+            FUNCTION_NOW+"()",
             null,
             "TIMESTAMP"
         );
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/date/TimestampFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/date/TimestampFunction.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/date/TimestampFunction.java	(revision 44198)
@@ -4,15 +4,16 @@
 import java.text.SimpleDateFormat;
 import java.util.Date;
 import org.apache.commons.lang3.Range;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_TIMESTAMP;
 import org.gvsig.expressionevaluator.Interpreter;
 import org.gvsig.expressionevaluator.spi.AbstractFunction;
 
 public class TimestampFunction extends AbstractFunction {
 
     public TimestampFunction() {
-        super("Date", "TIMESTAMP",Range.between(1,2),
+        super("Date", FUNCTION_TIMESTAMP,Range.between(1,2),
             "Returns a time stamp from the arguments",
-            "TIMESTAMP({{timestamp}}, format)",
+            FUNCTION_TIMESTAMP+"({{timestamp}}, format)",
             new String[]{
                 "timestamp - a string with a date/time",
                 "format - Optional. Format to use to parse the timestamp"
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/spatial/AndAndOperator.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/spatial/AndAndOperator.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/spatial/AndAndOperator.java	(revision 44198)
@@ -0,0 +1,32 @@
+package org.gvsig.expressionevaluator.impl.function.spatial;
+
+import org.gvsig.expressionevaluator.impl.function.operator.*;
+import org.gvsig.expressionevaluator.Function;
+import org.gvsig.expressionevaluator.Interpreter;
+import org.gvsig.fmap.geom.Geometry;
+import org.gvsig.fmap.geom.GeometryUtils;
+
+public class AndAndOperator extends AbstractBinaryOperator {
+    
+    public static final String NAME = "&&";
+
+    public AndAndOperator() {
+        super(Function.GROUP_OGC, NAME);
+    }
+
+    @Override
+    public boolean allowConstantFolding() {
+        return true;
+    }
+    
+    @Override
+    public Object call(Interpreter interpreter, Object op1, Object op2) {       
+        if( op1 instanceof Geometry && op2 instanceof Geometry ) {
+            boolean value = GeometryUtils.intersects((Geometry)op1,(Geometry) op2);
+            return value;
+        }
+        throw new IllegalArgumentException("Types not allowed in '"+name()+"' operand.");
+    }
+    
+
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/string/LowerFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/string/LowerFunction.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/string/LowerFunction.java	(revision 44198)
@@ -1,13 +1,14 @@
 package org.gvsig.expressionevaluator.impl.function.string;
 
 import org.apache.commons.lang3.Range;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_LOWER;
 import org.gvsig.expressionevaluator.Interpreter;
 import org.gvsig.expressionevaluator.spi.AbstractFunction;
 
 public class LowerFunction extends AbstractFunction {
 
     public LowerFunction() {
-        super("String", "LOWER", Range.is(1));
+        super("String", FUNCTION_LOWER, Range.is(1));
         this.addAlias("LCASE");
         this.addAlias("toLowerCase");
     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/typeconversion/ToFloatFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/typeconversion/ToFloatFunction.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/typeconversion/ToFloatFunction.java	(revision 44198)
@@ -0,0 +1,30 @@
+package org.gvsig.expressionevaluator.impl.function.typeconversion;
+
+import org.apache.commons.lang3.Range;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_TOFLOAT;
+import org.gvsig.expressionevaluator.Interpreter;
+import org.gvsig.expressionevaluator.spi.AbstractFunction;
+import org.gvsig.tools.ToolsLocator;
+import org.gvsig.tools.dataTypes.DataTypes;
+import org.gvsig.tools.dataTypes.DataTypesManager.Coercion;
+
+public class ToFloatFunction extends AbstractFunction {
+
+    public ToFloatFunction() {
+        super(GROUP_CONVERSION, FUNCTION_TOFLOAT, Range.is(1));
+        this.addAlias("float");
+    }
+
+    @Override
+    public boolean allowConstantFolding() {
+        return true;
+    }
+    
+    @Override
+    public Object call(Interpreter interpreter, Object[] args) throws Exception {
+        Coercion toStr = ToolsLocator.getDataTypesManager().getCoercion(DataTypes.FLOAT);
+        Object value = toStr.coerce(this.getObject(args, 0));
+        return value;
+    }
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/typeconversion/CastFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/typeconversion/CastFunction.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/typeconversion/CastFunction.java	(revision 44198)
@@ -2,6 +2,7 @@
 
 import java.util.Iterator;
 import org.apache.commons.lang3.Range;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_CAST;
 import org.gvsig.expressionevaluator.ExpressionRuntimeException;
 import org.gvsig.expressionevaluator.Interpreter;
 import org.gvsig.expressionevaluator.spi.AbstractFunction;
@@ -13,10 +14,8 @@
 
 public class CastFunction extends AbstractFunction {
     
-    public static final String NAME = "CAST";
-
     public CastFunction() {
-        super("Conversion", NAME, Range.is(2));
+        super(GROUP_CONVERSION, FUNCTION_CAST, Range.is(2));
     }
 
     @Override
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/typeconversion/ToStrFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/typeconversion/ToStrFunction.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/typeconversion/ToStrFunction.java	(revision 44198)
@@ -0,0 +1,31 @@
+package org.gvsig.expressionevaluator.impl.function.typeconversion;
+
+import org.apache.commons.lang3.Range;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_TOSTR;
+import org.gvsig.expressionevaluator.Interpreter;
+import org.gvsig.expressionevaluator.spi.AbstractFunction;
+import org.gvsig.tools.ToolsLocator;
+import org.gvsig.tools.dataTypes.DataTypes;
+import org.gvsig.tools.dataTypes.DataTypesManager.Coercion;
+
+public class ToStrFunction extends AbstractFunction {
+
+    public ToStrFunction() {
+        super(GROUP_CONVERSION, FUNCTION_TOSTR, Range.is(1));
+        this.addAlias("STR");
+        this.addAlias("toString");
+    }
+
+    @Override
+    public boolean allowConstantFolding() {
+        return true;
+    }
+    
+    @Override
+    public Object call(Interpreter interpreter, Object[] args) throws Exception {
+        Coercion toStr = ToolsLocator.getDataTypesManager().getCoercion(DataTypes.STRING);
+        Object value = toStr.coerce(this.getObject(args, 0));
+        return value;
+    }
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/typeconversion/ToDoubleFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/typeconversion/ToDoubleFunction.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/typeconversion/ToDoubleFunction.java	(revision 44198)
@@ -0,0 +1,32 @@
+package org.gvsig.expressionevaluator.impl.function.typeconversion;
+
+import org.apache.commons.lang3.Range;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_TODOUBLE;
+import org.gvsig.expressionevaluator.Interpreter;
+import org.gvsig.expressionevaluator.spi.AbstractFunction;
+import org.gvsig.tools.ToolsLocator;
+import org.gvsig.tools.dataTypes.DataTypes;
+import org.gvsig.tools.dataTypes.DataTypesManager.Coercion;
+
+public class ToDoubleFunction extends AbstractFunction {
+
+    public ToDoubleFunction() {
+        super(GROUP_CONVERSION, FUNCTION_TODOUBLE, Range.is(1));
+        this.addAlias("double");
+        this.addAlias("toReal");
+        this.addAlias("toNumber");
+    }
+
+    @Override
+    public boolean allowConstantFolding() {
+        return true;
+    }
+    
+    @Override
+    public Object call(Interpreter interpreter, Object[] args) throws Exception {
+        Coercion toStr = ToolsLocator.getDataTypesManager().getCoercion(DataTypes.DOUBLE);
+        Object value = toStr.coerce(this.getObject(args, 0));
+        return value;
+    }
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/typeconversion/ToIntegerFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/typeconversion/ToIntegerFunction.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/typeconversion/ToIntegerFunction.java	(revision 44198)
@@ -0,0 +1,31 @@
+package org.gvsig.expressionevaluator.impl.function.typeconversion;
+
+import org.apache.commons.lang3.Range;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_TOINTEGER;
+import org.gvsig.expressionevaluator.Interpreter;
+import org.gvsig.expressionevaluator.spi.AbstractFunction;
+import org.gvsig.tools.ToolsLocator;
+import org.gvsig.tools.dataTypes.DataTypes;
+import org.gvsig.tools.dataTypes.DataTypesManager.Coercion;
+
+public class ToIntegerFunction extends AbstractFunction {
+
+    public ToIntegerFunction() {
+        super(GROUP_CONVERSION, FUNCTION_TOINTEGER, Range.is(1));
+        this.addAlias("int");
+        this.addAlias("toint");
+    }
+
+    @Override
+    public boolean allowConstantFolding() {
+        return true;
+    }
+    
+    @Override
+    public Object call(Interpreter interpreter, Object[] args) throws Exception {
+        Coercion toStr = ToolsLocator.getDataTypesManager().getCoercion(DataTypes.INT);
+        Object value = toStr.coerce(this.getObject(args, 0));
+        return value;
+    }
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/typeconversion/ToLongFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/typeconversion/ToLongFunction.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/typeconversion/ToLongFunction.java	(revision 44198)
@@ -0,0 +1,30 @@
+package org.gvsig.expressionevaluator.impl.function.typeconversion;
+
+import org.apache.commons.lang3.Range;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_TOLONG;
+import org.gvsig.expressionevaluator.Interpreter;
+import org.gvsig.expressionevaluator.spi.AbstractFunction;
+import org.gvsig.tools.ToolsLocator;
+import org.gvsig.tools.dataTypes.DataTypes;
+import org.gvsig.tools.dataTypes.DataTypesManager.Coercion;
+
+public class ToLongFunction extends AbstractFunction {
+
+    public ToLongFunction() {
+        super(GROUP_CONVERSION, FUNCTION_TOLONG, Range.is(1));
+        this.addAlias("long");
+    }
+
+    @Override
+    public boolean allowConstantFolding() {
+        return true;
+    }
+    
+    @Override
+    public Object call(Interpreter interpreter, Object[] args) throws Exception {
+        Coercion toStr = ToolsLocator.getDataTypesManager().getCoercion(DataTypes.LONG);
+        Object value = toStr.coerce(this.getObject(args, 0));
+        return value;
+    }
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/typeconversion/DecodeFunction.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/typeconversion/DecodeFunction.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/typeconversion/DecodeFunction.java	(revision 44198)
@@ -0,0 +1,47 @@
+package org.gvsig.expressionevaluator.impl.function.typeconversion;
+
+import org.apache.commons.codec.binary.Base64;
+import org.apache.commons.codec.binary.Hex;
+import org.apache.commons.lang3.Range;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.FUNCTION_DECODE;
+import org.gvsig.expressionevaluator.Interpreter;
+import org.gvsig.expressionevaluator.spi.AbstractFunction;
+
+public class DecodeFunction extends AbstractFunction {
+
+    public DecodeFunction() {
+        super(
+            GROUP_CONVERSION, FUNCTION_DECODE, Range.is(2),
+            "Decode binary data from textual representation in string.\nSupported formats are: base64, hex.",
+            FUNCTION_DECODE+"({{data}}, 'hex')",
+            new String[]{
+                "data - A string value with the data to be converted",
+                "format - A string value indicating the format of the input data. The default value is 'hex'."
+            },
+            "Byte array",
+            true
+        );
+    }
+
+    @Override
+    public boolean allowConstantFolding() {
+        return true;
+    }
+    
+    @Override
+    public Object call(Interpreter interpreter, Object[] args) throws Exception {
+        String data_s = getStr(args,0);
+        String type = getStr(args,1);
+        if( "hex".equalsIgnoreCase(type) ) {
+            byte[] data = Hex.decodeHex(data_s.toCharArray());
+            return data;
+        } else if( "base64".equalsIgnoreCase(type) ) {
+            byte[] data = Base64.decodeBase64(data_s);
+            return data;
+        } else if( "escape".equalsIgnoreCase(type) ) {
+            // Not supported
+        }
+        throw new IllegalArgumentException("Unsupported format type '"+type+"'.");
+    }
+
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultInterpreter.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultInterpreter.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultInterpreter.java	(revision 44198)
@@ -165,23 +165,9 @@
 
     @Override
     public void link(Code code) {
-        linkCode(code);
+        code.link(this.getSymbolTable());
     }
 
-    private void linkCode(Code code) {
-        if( code.code() == Code.CALLER ) {
-            Caller caller = (Caller) code;
-            if( caller.function() == null ) {
-                caller.function(this.getSymbolTable().function(caller.name()));
-            }
-            if( caller.args() != null ) {
-                for( Code arg : caller.args() ) {
-                    linkCode(arg);
-                }
-            }
-        }
-    }
-
     public Object runCode(Code code) throws Exception {
         RecursionControlSupport recursionControl = null;
         if( code instanceof RecursionControlSupport ) {
@@ -235,7 +221,7 @@
                 if( !function.isSQLCompatible() && this.sqlCompatible ) {
                     throw new ExpressionRuntimeException(code, I18N.Cant_use_non_SQL_compatible_functions(function.name()));
                 }
-                Codes args = caller.args();
+                Codes args = caller.parameters();
                 try {
                     switch( caller.type() ) {
                     case Caller.UNARY_OPERATOR:
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultStatement.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultStatement.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultStatement.java	(revision 44198)
@@ -315,7 +315,7 @@
             for (Code arg : base_args) {
                 if( arg.code() == Code.CALLER && 
                     ((Caller)arg).name().equals(CodeBlockFunction.NAME) ) {
-                    Codes block_args = ((Caller)arg).args();
+                    Codes block_args = ((Caller)arg).parameters();
                     for (Code block_arg : block_args) {
                         args.add(block_arg);
                     }
